#pragma once
#include "CodeInjector.h"

struct REVERSED CModel
{
	DWORD					__vmt;		// 0000
	DWORD					modelNameHash;		// 0004
	WORD					usageCount;		// 0008
	WORD					txdIndex;		// 000A
	BYTE					field_C;		// 000C
	BYTE					count2dfx;		// 000D
	WORD					index2dFx;		// 000E
	WORD					objectInfoIndex;		// 0010
	WORD					flags;		// 0012
	DWORD					colModel;		// 0014
	DWORD					drawDist;		// 0018
	DWORD					rwObject;		// 001C
};

class REVERSED CClumpModel : public CModel
{
public:
	union 
	{
		int ifpIndex;
		char * ifpName;	
	}	_ifp;		// 0020
};

enum VehicleType
{
	VT_MTRUCK	= 1,
	VT_QUAD		= 2,
	VT_HELI		= 3,
	VT_PLANE	= 4,
	VT_AUTO		= 5,
	VT_TRAIN	= 6,
	VT_AUTO1	= 7,
	VT_AUTO2	= 8,
	VT_BIKE		= 9,
	VT_BMX		= 10,
	VT_TRAILER	= 11,
	VT_UNK		= -1
};

struct REVERSED CVehicleModel : public CClumpModel
{
	DWORD					LicensePlateMaterial;	// 0024
	char					licenseplateText[0x8];	// 0028
	BYTE					field_30;				// 0030
	BYTE					field_31;				// 0031
	char					gamename[0x8];			// 0032
	WORD					field_3A;				// 003A
	VehicleType				type;					// 003C
	DWORD					_p2;					// 0040
	DWORD					_p3;					// 0044
	WORD					_p1;					// 0048
	WORD					handlingIndex;			// 004A
	BYTE					field_4C;				// 004C
	BYTE					vehicleClass;			// 004D
	BYTE					vehicleFlags;			// 004E
	BYTE					_p4;					// 004F
	WORD					field_50;				// 0050
	WORD					frq;					// 0052
	DWORD					comprules;				// 0054
	DWORD					field_58;				// 0058
	DWORD					vehicleStruct;			// 005C
	DWORD					field_60;		// 0060
	DWORD					field_64;		// 0064
	DWORD					field_68;		// 0068
	DWORD					field_6C;		// 006C
	DWORD					field_70;		// 0070
	DWORD					field_74;		// 0074
	DWORD					field_78;		// 0078
	DWORD					field_7C;		// 007C
	DWORD					field_80;		// 0080
	DWORD					field_84;		// 0084
	DWORD					field_88;		// 0088
	DWORD					field_8C;		// 008C
	DWORD					field_90;		// 0090
	DWORD					field_94;		// 0094
	DWORD					field_98;		// 0098
	DWORD					field_9C;		// 009C
	DWORD					field_A0;		// 00A0
	DWORD					field_A4;		// 00A4
	DWORD					field_A8;		// 00A8
	DWORD					field_AC;		// 00AC
	DWORD					field_B0;		// 00B0
	DWORD					field_B4;		// 00B4
	DWORD					field_B8;		// 00B8
	DWORD					field_BC;		// 00BC
	DWORD					field_C0;		// 00C0
	DWORD					field_C4;		// 00C4
	DWORD					field_C8;		// 00C8
	DWORD					field_CC;		// 00CC
	DWORD					field_D0;		// 00D0
	DWORD					field_D4;		// 00D4
	DWORD					field_D8;		// 00D8
	DWORD					field_DC;		// 00DC
	DWORD					field_E0;		// 00E0
	DWORD					field_E4;		// 00E4
	DWORD					field_E8;		// 00E8
	DWORD					field_EC;		// 00EC
	DWORD					field_F0;		// 00F0
	DWORD					field_F4;		// 00F4
	DWORD					field_F8;		// 00F8
	DWORD					field_FC;		// 00FC
	DWORD					field_100;		// 0100
	DWORD					field_104;		// 0104
	DWORD					field_108;		// 0108
	DWORD					field_10C;		// 010C
	DWORD					field_110;		// 0110
	DWORD					field_114;		// 0114
	DWORD					field_118;		// 0118
	DWORD					field_11C;		// 011C
	DWORD					field_120;		// 0120
	DWORD					field_124;		// 0124
	DWORD					field_128;		// 0128
	DWORD					field_12C;		// 012C
	DWORD					field_130;		// 0130
	DWORD					field_134;		// 0134
	DWORD					field_138;		// 0138
	DWORD					field_13C;		// 013C
	DWORD					field_140;		// 0140
	DWORD					field_144;		// 0144
	DWORD					field_148;		// 0148
	DWORD					field_14C;		// 014C
	DWORD					field_150;		// 0150
	DWORD					field_154;		// 0154
	DWORD					field_158;		// 0158
	DWORD					field_15C;		// 015C
	DWORD					field_160;		// 0160
	DWORD					field_164;		// 0164
	DWORD					field_168;		// 0168
	DWORD					field_16C;		// 016C
	DWORD					field_170;		// 0170
	DWORD					field_174;		// 0174
	DWORD					field_178;		// 0178
	DWORD					field_17C;		// 017C
	DWORD					field_180;		// 0180
	DWORD					field_184;		// 0184
	DWORD					field_188;		// 0188
	DWORD					field_18C;		// 018C
	DWORD					field_190;		// 0190
	DWORD					field_194;		// 0194
	DWORD					field_198;		// 0198
	DWORD					field_19C;		// 019C
	DWORD					field_1A0;		// 01A0
	DWORD					field_1A4;		// 01A4
	DWORD					field_1A8;		// 01A8
	DWORD					field_1AC;		// 01AC
	DWORD					field_1B0;		// 01B0
	DWORD					field_1B4;		// 01B4
	DWORD					field_1B8;		// 01B8
	DWORD					field_1BC;		// 01BC
	DWORD					field_1C0;		// 01C0
	DWORD					field_1C4;		// 01C4
	DWORD					field_1C8;		// 01C8
	DWORD					field_1CC;		// 01CC
	DWORD					field_1D0;		// 01D0
	DWORD					field_1D4;		// 01D4
	DWORD					field_1D8;		// 01D8
	DWORD					field_1DC;		// 01DC
	DWORD					field_1E0;		// 01E0
	DWORD					field_1E4;		// 01E4
	DWORD					field_1E8;		// 01E8
	DWORD					field_1EC;		// 01EC
	DWORD					field_1F0;		// 01F0
	DWORD					field_1F4;		// 01F4
	DWORD					field_1F8;		// 01F8
	DWORD					field_1FC;		// 01FC
	DWORD					field_200;		// 0200
	DWORD					field_204;		// 0204
	DWORD					field_208;		// 0208
	DWORD					field_20C;		// 020C
	DWORD					field_210;		// 0210
	DWORD					field_214;		// 0214
	DWORD					field_218;		// 0218
	DWORD					field_21C;		// 021C
	DWORD					field_220;		// 0220
	DWORD					field_224;		// 0224
	DWORD					field_228;		// 0228
	DWORD					field_22C;		// 022C
	DWORD					field_230;		// 0230
	DWORD					field_234;		// 0234
	DWORD					field_238;		// 0238
	DWORD					field_23C;		// 023C
	DWORD					field_240;		// 0240
	DWORD					field_244;		// 0244
	DWORD					field_248;		// 0248
	DWORD					field_24C;		// 024C
	DWORD					field_250;		// 0250
	DWORD					field_254;		// 0254
	DWORD					field_258;		// 0258
	DWORD					field_25C;		// 025C
	DWORD					field_260;		// 0260
	DWORD					field_264;		// 0264
	DWORD					field_268;		// 0268
	DWORD					field_26C;		// 026C
	DWORD					field_270;		// 0270
	DWORD					field_274;		// 0274
	DWORD					field_278;		// 0278
	DWORD					field_27C;		// 027C
	DWORD					field_280;		// 0280
	DWORD					field_284;		// 0284
	DWORD					field_288;		// 0288
	DWORD					field_28C;		// 028C
	DWORD					field_290;		// 0290
	DWORD					field_294;		// 0294
	DWORD					field_298;		// 0298
	DWORD					field_29C;		// 029C
	DWORD					field_2A0;		// 02A0
	DWORD					field_2A4;		// 02A4
	DWORD					field_2A8;		// 02A8
	DWORD					field_2AC;		// 02AC
	BYTE					primaryColors[0x10];	// 02B0
	BYTE					secondaryColors[0x10];	// 02C0
	BYTE					field_2D0;		// 02D0
	BYTE					field_2D1;		// 02D1
	BYTE					field_2D2;		// 02D2
	BYTE					field_2D3;		// 02D3
	BYTE					field_2D4;		// 02D4
	BYTE					field_2D5;		// 02D5
	WORD					carMods[0x12];	// 02D6
	DWORD					field_2FA;		// 02FA
	DWORD					field_2FE;		// 02FE
	WORD					field_302;		// 0302
	union 
	{
		int carIfpIndex;
		char * carIfpName; 
	}						_carIfp;		// 0304
};

VALIDATE_SIZE(CVehicleModel, 0x308);
